#include <iostream>
using namespace std;

#include <math.h>

#include "main.h"
#include "bspline.h"

BsplineErr
bspline_eval( 
  double theta, 
  double zn, 
  SplineInfo& spinfo, 
  double* s
)
{
   return  Bspline_eval( theta, zn, spinfo.bsp, s );
}


BsplineErr
bspline_eval_derivs(
  double theta, 
  double zn, 
  SplineInfo& spinfo, 
  BsplineResult* bspres
)
{
   return Bspline_eval_derivs( theta, zn, spinfo.bsp, bspres );
}


BsplineErr
bspline_algc_eval( 
  double theta, 
  double zn, 
  SplineInfo& spinfo, 
  double* s
)
{
   return  BsplineAlgo_c( theta, zn, spinfo.bsp, s );
}


BsplineErr
bspline_algc_eval_derivs(
  double theta, 
  double zn, 
  SplineInfo& spinfo, 
  BsplineResult* bspres
)
{
   return BsplineAlgo_c_derivs( theta, zn, spinfo.bsp, bspres );
}
