#include <stdio.h>
#include <stdlib.h>
#include <libgen.h>

#include <Exception/Exception.h>

#include "main.h"

void usage( void );

int
main(int argc, char *argv[]) {

  if ( argc != 4 ) {

    fprintf( stderr, "Usage: %s output_prefix input_file num\n", argv[0] );
    return EXIT_FAILURE;

  }

  try {

    Common c;
    c.prgname = argv[0];
    c.prefix  = argv[1];
    c.input   = argv[2];
    c.num     = atoi( argv[3] );

    return process(&c);

  } catch( std::exception &e ) {

    std::cerr << e.what() << "\n";
    return EXIT_FAILURE;

  } catch ( ... ) {

    cerr << "Unknown exception caught, got to love C++\n";
    return EXIT_FAILURE;

  }

}

