// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of Exception
//
// Exception is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// Exception is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include "Exception.h"

#include <iostream>
//#include <TraceFct.h>

using namespace std;

static void a( ) throw( Exception ) {

#ifdef TRACEFCT
    TraceFct tf( "a( ) throw( Exception)" );
#endif
  
  throw Exception( "an error msg from a( )\n" );

}

static void aa( ) throw( Exception ) {

  try {

#ifdef TRACEFCT
    TraceFct tf( "aa( ) throw( Exception)" );
#endif

    a( );

  } catch( Exception e ) {
    // catch( Exception e ) is on purpose to test copy constructor.
    // The funny thing is that the copy constructor is not called!
    throw;
  }

}

static void b( ) throw( Exception ) {

#ifdef TRACEFCT
    TraceFct tf( "b( ) throw( Exception)" );
#endif

  try {
    aa( );
  } catch( Exception& e ) {
    e.set_rethrow_message( __FILE__, __LINE__ );
    throw e;
  }

}

static void c( ) throw( Exception ) {

#ifdef TRACEFCT
    TraceFct tf( "c( ) throw( Exception)" );
#endif

  try {
    b( );
  } catch( Exception& e ) {
    RETHROWME( e );
  }

}

static void blahblah( ) throw( Exception ) {

#ifdef TRACEFCT
    TraceFct tf( "blahblah( ) throw( Exception)" );
#endif

  throw Exception( "a good bye msg from blahblah\n" );

}

int main( int argc, char* argv[] ) {

#ifdef TRACEFCT
  TraceFct tf( argv[0], 1, -1 );
#endif

  try {
    c( );
  } catch( Exception& e ) {
    cerr << e;
  }

  try {
    blahblah( );
  } catch( Exception& e ) {
    cerr << e;
  }

  return 0;

}
