use Test::More tests => 3;
BEGIN { use_ok('MST::Raytrace', 'get_centroid') };

my ( $cnt, $wt, $cnt_ghosts, $wt_ghosts );

# bad file
eval {
      get_centroid( 'non_existent_file' );
     
};
ok( $@ && $@ =~ /unable to open/, "non existent file" );

my %cres = get_centroid( 'data/centroid.rdb' );

my %expected = (
		n     => 15095,
		r_rms => 0.25974859939135,
		x_ave => 0.0031723853078835,
		y_ave => -6.8127755403322e-05,
		z_ave => 0,
		x_dev => 0.23770247203502,
		y_dev => 0.10469608531948,
		z_dev => 0,
		x_rms => 0.2376945983547,
		y_rms => 0.10469261735594,
		z_rms => 0,
	       );

ok( eq_hash(\%cres, \%expected), "centroid" );
