use Test::More tests => 4;
BEGIN { use_ok('MST::Raytrace', 'get_tot_wt') };

my ( $cnt, $wt, $cnt_ghosts, $wt_ghosts );

# bad file
eval {
      get_tot_wt( 'non_existent_file' );
     
};
ok( $@ && $@ =~ /unable to open/, "non existent file" );

( $cnt, $wt, $cnt_ghosts, $wt_ghosts ) = get_tot_wt( 'data/foo.totwt-out' );
ok(    $cnt == 38 
    && $wt  == 26.351665
    && !defined $cnt_ghosts
    && !defined $wt_ghosts,
     "no ghosts" );

( $cnt, $wt, $cnt_ghosts, $wt_ghosts ) = get_tot_wt( 'data/bar.totwt-out' );
ok(    $cnt == 210625
    && $wt  == 64836.318869
    && $cnt_ghosts == 18786
    && $wt_ghosts == 7586.420731,
    "ghosts"
    );
