use strict;
use File::Compare;

use vars qw( $loaded $tests $test);

BEGIN { 
      require "t/common.pl";
      $tests = 3; 
      $| = 1; 
      print "1..$tests\n"; 
      }
END {print "not ok 1\n" unless $loaded; unlink glob 'tmp-*'; }

use RDB;

$verbose = 0;
$test = 1;
$loaded = 1;
print "ok 1\n";


sub setup
{
  ++$test;
  my $file = "tmp-$test";

  my $rdb1 = new RDB TEST1_RDB;
  my $rdb = new RDB $file, '>' or return ();
  $rdb->init( $rdb1 );
  ( $rdb, $file );
}

# if any of the subs croak or die, there will be no return,
# which will cause the eval to return undef

ok eval {

  my ( $rdb, $file ) = setup(@_) or return undef;
  test( "single add_col" );
  $rdb->add_col( c4 => 'S' );
  $rdb->write_hdr;
  $rdb->close;

  ! compare( $file , TEST2_RDB );
};

# test changing of column information
ok eval {

  my ( $rdb, $file ) = setup(@_) or return undef;

  test( "double add_col" );

  $rdb->add_col( c4 => 'N' );
  $rdb->add_col( c4 => 'S' );
  $rdb->write_hdr;
  $rdb->close;

  ! compare( $file , TEST2_RDB );
};
