use vars qw( $verbose );

use constant TEST1_RDB => 't/test1.rdb';
use constant TEST1_TPL => 't/test1.tpl';

use constant TEST2_RDB => 't/test2.rdb';
use constant TEST2_TPL => 't/test2.tpl';

use constant TEST3_RDB => 't/test3.rdb';
use constant TEST3_TPL => 't/test3.tpl';

use constant TEST4_RDB => 't/test4.rdb';
use constant TEST4_TPL => 't/test4.tpl';
use constant TEST4_1_TPL => 't/test4.1.tpl';

use constant TEST5_RDB => 't/test5.rdb';
use constant TEST6_RDB => 't/test6.rdb';
use constant TEST7_RDB => 't/test7.rdb';
use constant TEST8_RDB => 't/test8.rdb';
use constant TEST9_RDB => 't/test9.rdb';

$verbose = 0;

sub test
{
  print "Test $test: ", @_, "\n"
    if $verbose;
}

sub ok($)
{
  print "Test $test: $@\n"
     if $verbose && $@;
  print shift() ? "ok $test\n" : "not ok $test\n";
}

sub notok($)
{
  print "Test $test: $@"
     if $verbose && $@;
  print shift() ? "not ok $test\n" : "ok $test\n";
}

sub cmp_hash
{
  my ( $h1, $h2 ) = @_;

  # reset iterator over %$h1
  keys %$h1;
  while ( my ( $key, $val ) = each %$h1 )
  {
    die ( "$key isn't in h2\n" ) unless exists $h2->{$key};
    die ( "$key doesn't have same value\n" )
      if $val ne $h2->{$key};

    delete $h2->{$key};
  }

  die( "excess in h2: ", join( ', ', keys %$h2 ), "\n" )
    if keys %$h2;
}

sub cmp_array
{
  my ( $a1, $a2 )= @_;

  return undef unless @$a1 == @$a2;

  for ( my $i = 0 ; $i < @$a1 ; $i++ )
  {
    return undef unless $a1->[$i] eq $a2->[$i];
  }

  1;
}

1;
