use strict;
use File::Compare;

use constant TEST_RDB => 't/test1.rdb';

use vars qw( $loaded $tests $test);

BEGIN { 
      require 't/common.pl';
      $tests = 7; 
      $| = 1; print "1..$tests\n"; }
END {print "not ok 1\n" unless $loaded; unlink glob 'tmp-*'; }

use RDB;

$verbose = 1;
$test = 1;
$loaded = 1;
print "ok 1\n";

sub setup
{
  $test++;
  my $rdb = new RDB TEST1_RDB or return undef;
}

# if any of the subs croak or die, there will be no return,
# which will cause the eval to return undef

ok eval { 

  my $rdb = setup(@_) or return undef;

  my %type = $rdb->defs;
  
  $type{c1}  eq 'N' &&
  $type{c2}  eq 'N' &&
  $type{c33} eq 'S';
};

ok eval { 

  my $rdb = setup(@_) or return undef;

  my @type = $rdb->defs( qw( c1 c2 c33 ));
  
  $type[0] eq 'N' &&
  $type[1] eq 'N' &&
  $type[2] eq 'S';
};

ok eval { 

  my $rdb = setup(@_) or return undef;

  $rdb->defs( 'c1'  ) eq 'N' &&
  $rdb->defs( 'c2'  ) eq 'N' &&
  $rdb->defs( 'c33' ) eq 'S';
};

# ensure it handles old /rdb headers
ok eval {
  $test++;
  my $rdb = new RDB TEST7_RDB or return undef;

  $rdb->type( 'name' ) eq 'S' && $rdb->type( 'favor' ) eq 'S';
};

# this has a bogus header
notok eval {
  $test++;
  my $rdb = new RDB TEST8_RDB or return undef;
};

# this has a bogus header as well
notok eval {
  $test++;
  my $rdb = new RDB TEST9_RDB or return undef;
};
