use strict;
use File::Compare;
use Data::Dumper;

use vars qw( $loaded $tests $test $verbose $test5 );

BEGIN { 
  require "t/common.pl";
  $tests = 2; 
  $| = 1; print "1..$tests\n"; }
END {print "not ok 1\n" unless $loaded; unlink glob 'tmp-*'; }

use RDB;


$verbose = 1;
$test = 1;
$loaded = 1;
print "ok 1\n";

sub setup
{
  ++$test;
  my $file = "tmp-$test";

  my $rdb = new RDB $file, '>' or return ();
  ( $rdb, $file );
}


# if any of the subs croak or die, there will be no return,
# which will cause the eval to return undef

# read into hash
ok eval { 

  my ( $rdb, $file ) = setup() or return undef;

  my $rdb_i = new RDB TEST5_RDB or die;

  $rdb->init( $rdb_i );
  $rdb->delete_col( 'bunk' );

  my %data;
  my $n = 0;
  while ( $rdb_i->read( \%data ) )
  {
    $rdb->write( \%data );
  }

  $rdb->close;
  0 == compare( $file, TEST6_RDB );
};
