use strict;
use File::Compare;
use Data::Dumper;

use vars qw( $loaded $tests $test $verbose $test5 );

BEGIN { 
  require "t/common.pl";
  require "t/test5.pl";
  $tests = 5; 
  $| = 1; print "1..$tests\n"; }
END {print "not ok 1\n" unless $loaded; unlink glob 'tmp-*'; }

use RDB;


$verbose = 1;
$test = 1;
$loaded = 1;
print "ok 1\n";

sub setup
{
  ++$test;

  my $rdb = new RDB TEST5_RDB or return ();
  $rdb;
}

# if any of the subs croak or die, there will be no return,
# which will cause the eval to return undef

# read into hash
ok eval { 

  my $rdb = setup or return undef;

  my %data;
  my $n = 0;
  while ( $rdb->read( \%data ) )
  {
    cmp_hash($test5->[$n], \%data );
    
    $n++;
  }

  1;
};

# bind to scalars
ok eval { 

  my $rdb = setup or return undef;

  my $name;
  my $bunk;
  my $favor;
  my $n = 0;

  $rdb->bind( { name => \$name, bunk => \$bunk , favor => \$favor } );

  while ( $rdb->read )
  {
    cmp_hash($test5->[$n], { name => $name, bunk => $bunk, favor => $favor } );
    
    $n++;
  }

  1;
};


# bind to scalars, but only read in first column
ok eval { 

  my $rdb = setup or return undef;

  my $name;
  my $n = 0;

  $rdb->bind( { name => \$name } );

  while ( $rdb->read )
  {
    cmp_hash({ name => $test5->[$n]{name} }, { name => $name } );
    
    $n++;
  }

  1;
};


# bind to arrays
ok eval { 

  my $rdb = setup or return undef;

  my @name;
  my @bunk;
  my @favor;
  my $n = 0;

  $rdb->bind( { name => \@name, bunk => \@bunk, favor => \@favor } );

  while ( $rdb->read )
  {
    cmp_hash($test5->[$n], { name => $name[$n], 
			     bunk => $bunk[$n],
			     favor => $favor[$n]
			   } );
    
    $n++;
  }

  1;
};
