use strict;
use File::Compare;

use constant TEST_RDB => 't/test1.rdb';

use vars qw( $loaded $tests $test);

BEGIN { $tests = 4; $| = 1; print "1..$tests\n"; }
END {print "not ok 1\n" unless $loaded; unlink glob 'tmp-*'; }

use RDB;

$test = 1;
$loaded = 1;
print "ok 1\n";

sub ok($)
{
  print shift() ? "ok $test\n" : "not ok $test\n";
}

sub notok
{
  print shift() ? "not ok $test\n" : "ok $test\n";
}

sub setup
{
  $test++;
  my $rdb = new RDB 't/test1.rdb' or return undef;
}

# if any of the subs croak or die, there will be no return,
# which will cause the eval to return undef

ok eval { 

  my $rdb = setup(@_) or return undef;

  my %type = $rdb->type;
  
  $type{c1}  eq 'N' &&
  $type{c2}  eq 'N' &&
  $type{c33} eq 'S';
};

ok eval { 

  my $rdb = setup(@_) or return undef;

  my @type = $rdb->type( qw( c1 c2 c33 ));
  
  $type[0] eq 'N' &&
  $type[1] eq 'N' &&
  $type[2] eq 'S';
};

ok eval { 

  my $rdb = setup(@_) or return undef;

  $rdb->type( 'c1'  ) eq 'N' &&
  $rdb->type( 'c2'  ) eq 'N' &&
  $rdb->type( 'c33' ) eq 'S';
};

