#ifndef ASSEMBLY_H
#define ASSEMBLY_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of aperture
 *
 * aperture is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * aperture is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <linklist/linklist.h>

#include "aperture.h"

typedef enum { ASSEMBLY, SUBASSEMBLY, ASSEMBLY_UNKNOWN } AssemblyType;

typedef struct {
  unsigned long id;
  int block;
  SLinkList leaves;
} Assembly;

typedef struct {
  unsigned long id;
  int block;
  size_t num_apertures;
  Aperture* apertures;
} AssemblyArray;

void        assembly_print_type( AssemblyType type );
const char* assembly_get_name( AssemblyType type );
void	    assembly_free( Assembly* assembly );
int	    assembly_init ( void* assembly, void* udata );
void	    assembly_print( Assembly* );
int	    assembly_cp( void *assembly, void *udata );

AssemblyArray* assembly_cvt_ll_to_array( SLinkList assembly_ll,
					 size_t* n_assemblies );

#endif /* ASSEMBLY_H */

