/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of aperture
 *
 * aperture is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * aperture is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <stddef.h>

#include "aperture.h"

/*

   Instructions For Inserting A New Module
   ---------------------------------------
   1. declare the module's ApertureModule structure
   2. insert it in the list of modules, *before*
      the last, NULL, entry.

*/

/****************************************
 * 1. Declare ApertureModule structures *
 ****************************************/
extern ApertureModule annulus_module;
extern ApertureModule block_module;
extern ApertureModule circle_module;
extern ApertureModule ellipse_module;
extern ApertureModule ell_module;
extern ApertureModule polygon_module;
extern ApertureModule rect_module;
extern ApertureModule strut_module;
extern ApertureModule pass_module;
extern ApertureModule print_photon_module;
extern ApertureModule wedge_module;
extern ApertureModule wedger_module;
extern ApertureModule wedger2_module;

/* -- declare new module structures above this line  -- */

#ifdef TEST
extern ApertureModule test1_module;
#endif

/****************************************
 * 2. Insert the module structure       *
 ****************************************/
ApertureModule *modules[] =
{
  &annulus_module,
  &block_module,
  &circle_module,
  &ellipse_module,
  &ell_module,
  &polygon_module,
  &rect_module,
  &strut_module,
  &pass_module,
  &print_photon_module,
  &wedge_module,
  &wedger_module,
  &wedger2_module,

/* -- place new module structures above this line  -- */

#ifdef TEST
  &test1_module,
#endif

  NULL
};
