#ifndef FunParamWrap_h
#define FunParamWrap_h

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of src
//
// src is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// src is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--


// we can't use this, as char* will be converted to bool, with really
// bad results. luckily we actually don't have a use for this (yet?)
//
// int FunWrapParamPut(Fun fun, char *name, int n, bool value, char *comm, int append);

int FunWrapParamPut(Fun fun, char *name, int n, int value, char *comm, int append);
int FunWrapParamPut(Fun fun, char *name, int n, unsigned int value, char *comm, int append);
int FunWrapParamPut(Fun fun, char *name, int n, long unsigned int value, char *comm, int append);
int FunWrapParamPut(Fun fun, char *name, int n, double value, char *comm, int append, int prec = DBL_DIG );
int FunWrapParamPut(Fun fun, char *name, int n, string value, char *comm, int append);
int FunWrapParamPut(Fun fun, char *name, int n, char *value, char *comm, int append);


template<typename T>
void ParamPut( 
  Fun fun, 
  string name,
  int idx,
  T val,
  char* comm,
  int append
  ) throw( Exception ) {

  TraceFct tf( "Bp2Fits::paramPut" );

  int funret = FunWrapParamPut( fun, (char*) name.c_str(), idx, val, comm, append );  

  if ( ! funret )
    throw Exception( (string) "Error writing FITS Header parameter " + name);
}

void ParamPut( 
  Fun fun, 
  string name,
  int idx,
  double val,
  char* comm,
  int append,
  int prec
  ) throw( Exception );

void ParamPutType( 
  Fun fun, 
  char type,
  string name,
  int idx,
  string val,
  char* comm,
  int append,
  int prec = DBL_DIG
  ) throw ( Exception );

#endif
