/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of src
 *
 * src is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * src is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */


#include <bpipe/bpipe.h>
#include <tracefct/tracefct.h>
#include <tracefct/exiterrvals.h>

#include "main.h"

BPipe *attach_bpipe( char *stream )
{
  BPipe * bpipe;
  
  tf_enter( "attach_bp" );
  
  if ( NULL == ( bpipe = bpipe_new( ) ) )
    tf_exit( ExitERR_misc, "unable to create new BPipe object",
	     bpipe_strerror( bpipe_errno ) );

  if ( bpipe_input( bpipe, stream ) )
    tf_exit( ExitERR_misc, "unable to attach to `%s': %s", stream,
	     bpipe_strerror( bpipe_errno ) );

  tf_leave();

  return bpipe;
}
