#ifndef FIELD_INFO_H
#define FIELD_INFO_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of bp2rdb
 *
 * bp2rdb is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * bp2rdb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <stdio.h>
#include <bpipe/bpipe.h>

typedef struct
{
  DpktField *dpktf;
  BPDataType type;
  BPMatrix  *matrix;
  size_t    offset;
  char*	    data;
  size_t    size;	
  int       putchar;
} FieldInfo;


int	dump_FieldInfo( FieldInfo* fi );
void    free_FieldInfo( FieldInfo *fi );
void    free_FieldInfo_arr( FieldInfo* fi[] );
FieldInfo*  new_FieldInfo( DpktField* dpktf );


#endif /* ! FIELD_INFO_H */
