/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of src
 *
 * src is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * src is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <stdlib.h>
#include <string.h>
#include <libgen.h>

#include <tracefct/tracefct.h>
#include <tracefct/exiterrvals.h>

#include "main.h"
#include "usage.h"
#include "help.h"

#include "config.h"

int
main (int argc, char *argv[])
{
  Param param;

  argv[0] = basename(argv[0]);
  tf_init( argv[0], 0, 0 );
  
  gparam( argc, argv, &param );

  if ( param.version )
    printf( "bp2rdb %s\n", VERSION );

  else if ( param.usage )
    usage( );

  else if ( param.help )
    help( );

  else
    process( &param );

  return EXIT_SUCCESS;
}

