#ifndef MAIN_H
#define MAIN_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of src
 *
 * src is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * src is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <bpipe/bpipe.h>
#include "field_info.h"

#define NAME_LENGTH 1024

typedef enum
{
  OE_None	   = 0x00,
  OE_HdrVariables  = 0x01,
  OE_Hdr           = 0x02,
  OE_Data          = 0x04,
  OE_All	   = 0xff
} OutputElements;

typedef struct
{
  int  version;
  int  help;
  int  usage;
  char input[NAME_LENGTH+1];
  char output[NAME_LENGTH+1];

  /* fields to (not) output */
  int    nfields;
  char** fields;

  OutputElements elements;
  
} Param;

BPipe *attach_bpipe(char *stream);

void  dump_dpkts( BPipe *bpipe, FieldInfo* fields[], FILE *output );

void dump_hdrs(BPipe *bpipe, FILE *output);

void dump_rdb_hdr(FieldInfo* fields[], FILE *output);


FieldInfo** get_output_dpktfs(BPipe* bpipe, int nfields, char* requested_field[]);

void gparam(int argc, char *argv[], Param *param);

void process (Param *param);


#endif /* !MAIN_H */
