/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of bpipe
 *
 * bpipe is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * bpipe is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include "bpipep.h"

BPerrno bpipe_errno = BPNOERROR;

#define nerrors (sizeof(errors) / sizeof(char *))
static char *errors[] =
{
  "no error",		/* BPNOERROR */
  "bad argument",	/* BPEBADARG */
  "out of memory",	/* BPENOMEM */
  "pipe error",		/* BPEBADPIPE */
  "i/o error",		/* BPEIOERR */
  "no such file",	/* BPNOFILE */
  "unknown error"
};
  
/*

  PROCEDURE
  bpipe_strerror - Get an error message string.

  DESCRIPTION
  @code{bpipe_strerror} returns a character string which describes
  the passed @code{BPipe} error code.  The passed string is static,
  so don't try to overwrite it.

  RETURNS
  A pointer to a character string.

*/
char *
bpipe_strerror( BPerrno errnum )
{

  return (errnum < 0 || errnum >= nerrors) ?
    errors[ nerrors - 1 ] : errors[ errnum ];
}
