/*                                                                
**  Copyright (C) 2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/* clfg.c

 Get parameters from a formatted parameter name

 */
#include <stdarg.h>

#include <stdio.h>

#undef PARAMETER_FILE_SOURCE
#include "parameter.h"


#ifdef __STDC__
int clfgetb(char *format, ...)
#else
int clfgetb(va_alist)
	va_dcl
#endif
{
        va_list args;
	char	param[SZ_PFLINE];

#ifdef __STDC__
        va_start(args, format);
#else
	char	*format;

	va_start(args);

	format = va_arg(args, char *);
#endif

    vsprintf(param, format, args);
    return clgetb(param);
}

#ifdef __STDC__
int clfgets(char *format, ...)
#else
int clfgets(va_alist)
	va_dcl
#endif
{
        va_list args;
	char	param[SZ_PFLINE];

#ifdef __STDC__
        va_start(args, format);
#else
	char	*format;

	va_start(args);

	format = va_arg(args, char *);
#endif

    vsprintf(param, format, args);
    return clgets(param);
}


#ifdef __STDC__
int clfgeti(char *format, ...)
#else
int clfgeti(va_alist)
	va_dcl
#endif
{
        va_list args;
	char	param[SZ_PFLINE];

#ifdef __STDC__
        va_start(args, format);
#else
	char	*format;

	va_start(args);

	format = va_arg(args, char *);
#endif

    vsprintf(param, format, args);
    return clgeti(param);
}



#ifdef __STDC__
double clfgetd(char *format, ...)
#else
double clfgetd(va_alist)
	va_dcl
#endif
{
        va_list args;
	char	param[SZ_PFLINE];

#ifdef __STDC__
        va_start(args, format);
#else
	char	*format;

	va_start(args);

	format = va_arg(args, char *);
#endif

    vsprintf(param, format, args);
    return clgetd(param);
}

#ifdef __STDC__
char *clfgstr(char *format, char *value, int length, ...)
#else
char *clfgstr(va_alist)
	va_dcl
#endif
{
        va_list args;
	char	param[SZ_PFLINE];

#ifdef __STDC__
        va_start(args, length);
#else
	char	*format;
	char	*value;
	int	 length;

	va_start(args);

	format = va_arg(args, char *);
	value  = va_arg(args, char *);
	length = va_arg(args, int);
#endif

    vsprintf(param, format, args);
    return clgstr(param, value, length);
}
