// dvm3_matrix.cc

// File:    dvm3_matrix.cc
// Author:  Terry Gaetz

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of dvm3
//
// dvm3 is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// dvm3 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <dvm3/dvm3_matrix.h>        // dvm3_Matrix

//=========================================================================
// orthonormalize a dvm3_DMatrix

void dvm3_Matrix::
orthonormalize()
{
  // assumes we start with almost orthonormal rows.

  vm_V3Math<double>::cross(&data_.m_[ERow1], 
                           &data_.m_[ERow2], &data_.m_[ERow0]);
    //
    // m[ERow1] = m[ERow2] ^ m[ERow0]

  vm_V3Math<double>::cross(&data_.m_[ERow0], 
                           &data_.m_[ERow1], &data_.m_[ERow2]);
    //
    // m[ERow0] = m[ERow1] ^ m[ERow2]

  vm_V3Math<double>::unitize( &data_.m_[ERow0] );
    //
    // make m[ERow0] a unit vector

  vm_V3Math<double>::unitize( &data_.m_[ERow1] );
    //
    // make m[ERow1] a unit vector

  vm_V3Math<double>::unitize( &data_.m_[ERow2] );
    //
    // make m[ERow2] a unit vector

  // we now have an orthonormal triad.
}


