#ifndef bpmap_h_INCLUDED
#define bpmap_h_INCLUDED

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of fits2bp
 *
 * fits2bp is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * fits2bp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <bpipe/bpipe.h>

#include <string>
using namespace std;

typedef struct
{
  string name;
  BPDataType type;
  BPMatrix *mx;
  int used;
} BPipeMap_bpList_Entry;

typedef struct
{
  string name;
  BPipeMap_bpList_Entry *bp;
  BPDataType type;
  int alien_type;
  size_t offset;
  size_t col;
  size_t extent;
  void *addr;
} BPipeMap_mapList_Entry;

int	bpList_node_cmp( const void *dp1, const void *dp2 );
int	bpList_key_cmp( const void *key, const void *dp2 );
int	bpList_node_dump( void *node );
void	bpList_delete( BPipeMap_bpList_Entry* entry );
BPipeMap_bpList_Entry* new_bpList_Entry( const string& err_pfx,
					 const string& name,
					 BPDataType type, int ext, int used );

int	mapList_node_cmp( const void *dp1, const void *dp2 );
int	mapList_key_cmp( const void *key, const void *dp2 );
int	mapList_node_dump( void *node );
void	mapList_delete( BPipeMap_mapList_Entry* entry );
BPipeMap_mapList_Entry* new_mapList_Entry( const string& err_pfx,
					   const string& name,
					   BPipeMap_bpList_Entry *bps, 
					   size_t offset,
					   BPDataType type,
					   size_t col );

#endif
