#ifndef fits2bp_h_INCLUDED
#define fits2bp_h_INCLUDED 

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of fits2bp
 *
 * fits2bp is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * fits2bp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <bpipe/bpipe.h>

typedef struct
{
  BPipe *bp;
  BPipeOutput *bpo;
  void *data;
} Output;

#include <fitsio.h>

typedef struct
{
  fitsfile *fptr;
} Input;

typedef struct
{
  int  type;
  void *addr;
  size_t col;
  size_t extent;
} Column;

int usage( void );


#endif
