// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of fits2bp
//
// fits2bp is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// fits2bp is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <fitsio.h>
#include <tracefctxx/TraceFct.h>

#include "fits_error.h"

void
fits_error( char* err_pfx, int status )
{
  TraceFct tf( "fits_error" );
  char err_msg[100];

  if ( 0 == status )
    return ;

  while ( fits_read_errmsg( err_msg ) )
  {
    tf.message( "%s: %s\n", err_pfx, err_msg );
  }
  tf.exit( 1, "error in cfitsio routine" );
}
