#ifndef FLATBPIPE_H
#define FLATBPIPE_H

/*
 * Source     : flatbpipe.h
 * Author     : David Grumm
 * Description: encapsulate bpipe stuff
 */

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of flat
 *
 * flat is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * flat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <unistd.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include <tracefct/tracefct.h>
#include <tracefct/exiterrvals.h>
#include <bpipe/datatypes.h>
#include <mathconst/mathconst.h>

#include <bpipe/bpipe.h>
#include <bpipe/bpipe_axaf.h>

#include "flatbpiperay.h"

typedef struct {
  void *bpipe;
  void *data;
  BPipeOutput *outstream;
} Bpipe;

typedef enum { DIM0, DIM1, DIM2, DIM3, DIM4 } Dim;
typedef enum { XAXIS, YAXIS, ZAXIS } XYZaxis;

#ifdef PI
#undef PI
#endif
#define PI 3.14159265358979323846

#endif /* FLATBPIPE_H */








