/****************************************************************
 * Source     : gparam.c
 */

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of flat
 *
 * flat is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * flat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <tracefct/tracefct.h>
#include <tracefct/exiterrvals.h>
#include <tparam/tparam.h>
#include <stdio.h>
#include <stdlib.h>

#include "main.h"
#include "common.h"

void
gparam(int argc, char *argv[])
{

  paramfile pf;
  
  tf_enter("gparam");
  pf = tparamopen(NULL, argv, argc, "r");
  
  tpgetstr(pf, "input",	src.input, NAME_SIZE, 1);

  tpgetstr(pf, "output", src.output, NAME_SIZE, 1);

  tpgetstr(pf, "debug", src.debug,   DEBUG_LENGTH, 0);
  if ( 0 == strcmp( src.debug, "verify" ) )
    src.printdebug = 1;
  else
    src.printdebug = 0;

  src.srfno = tpgeti(pf, "surf_no");
  src.x0 = tpgetd(pf, "x0");
  src.y0 = tpgetd(pf, "y0");
  src.z0 = tpgetd(pf, "z0");
  src.height = tpgetd(pf, "height");
  src.width = tpgetd(pf, "width");
  src.rotation = tpgetd(pf, "rotation");
  src.normx = tpgetd(pf, "normx");
  src.normy = tpgetd(pf, "normy");
  src.normz = tpgetd(pf, "normz");
 
  src.help = tpgetb(pf, "help" );
  src.version = tpgetb(pf, "version");
  
  debug_init(src.debug);

  paramclose(pf);
  tf_leave();

}
