#ifndef DTNBPIPE_H
#define DTNBPIPE_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of flat
 *
 * flat is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * flat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

typedef struct {
  void *bpipe;
  void *data;
  BPipeOutput *outstream;
} Bpipe;

typedef struct {
  char *in;                                                 /* input stream */
  char *out;                                               /* output stream */
} InOut;

typedef struct
{
  DVector3 *position; 
  DVector3 *direction;
  double   *weight;
  double   *energy;
} Photon;

#endif
