/****************************************************************
 * Source     : vector_ops.c
 */

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of flat
 *
 * flat is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * flat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <math.h>

#include <bpipe/bpipe.h>
#include <bpipe/bpipe_axaf.h>
#include <bpipe/datatypes.h>
#include <randlib_c/randlib.h>
#include <tracefct/tracefct.h>

double dot_product( DVector3* a, DVector3* b ) {

  double result;

  result = a->x * b->x;
  result += a->y * b->y;
  result += a->z * b->z;

  return result;
}

/* added normalization procedure*/
void normalize( DVector3 *vector ) {

  double normalization = sqrt( dot_product( vector, vector ) );

  vector->x /= normalization;
  vector->y /= normalization;
  vector->z /= normalization;

}
