#include <tparam/tparam.h>
#include <tracefct/tracefct.h>

#include <suplib/debug.h>

#include "main.h"

void
gparam(int argc, char *argv[], Global *g)
{
  paramfile pf;

  tf_enter("gparam");

  pf = tparamopen(NULL, argv, argc, "r");

  /* get debug flags */
  tpgetstr(pf, "debug", g->debug, NAME_LENGTH, 0);
  debug_init(g->debug);

  /* get input file */
  tpgetstr(pf, "input", g->input, NAME_LENGTH, 1);

  /* get output file */
  tpgetstr(pf, "output", g->output, NAME_LENGTH, 1);
  
  /* get surface number */
  g->surf_num =  tpgeti(pf, "surf_num" );
  
  g->version = tpgetb( pf, "version" );
  g->help = tpgetb( pf, "help" );

  paramclose(pf);
  
  tf_leave();
}
