/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of genphot
 *
 * genphot is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * genphot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include "main.h"

Common c;

extern OutputGeometry rect_peri_geo;
extern OutputGeometry rect_fill_geo;
extern OutputGeometry circ_peri_geo;
extern OutputGeometry ellipse_fill_geo;
extern OutputGeometry annulus_fill_geo;
extern OutputGeometry point_geo;

OutputGeometry* OutputGeometries[] =
{
  &rect_peri_geo,
  &ellipse_fill_geo,
  &rect_fill_geo,
  &circ_peri_geo,
  &annulus_fill_geo,
  &point_geo
};
size_t nOutputGeometries = sizeof(OutputGeometries) / sizeof(OutputGeometry *);

extern OutputDistribution uniform_dist;
extern OutputDistribution grid_dist;

OutputDistribution* OutputDistributions[] =
{
  &uniform_dist,
  &grid_dist
};
size_t nOutputDistributions =
  sizeof(OutputDistributions) / sizeof(OutputDistribution *);
