#ifndef FLUX_H
#define FLUX_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of genphot
 *
 * genphot is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * genphot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

typedef enum
{
  EnDist_min,
  EnDist_max,
  EnDist_ave,
  EnDist_sample,
  EnDist_picket
} EnergyDist;

typedef struct {
  double emin;                /* lower bound of energy in bin */
  double emax;                /* upper bound of energy in bin */
  double counts;              /* number of counts in bin */
  double cumint;              /* fraction of counts in current bin or lower*/ 
  double precumint;           /* cumint of next lower bin */ 
} Flux;

#endif
