/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of genphot
 *
 * genphot is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * genphot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

/* uniform.c  */

#include <mathconst/mathconst.h>
#include <tracefct/tracefct.h>
#include <tparam/tparam.h>
#include <randlib_c/randlib.h>

#include "main.h"
#include "common.h"

/*---------------------------------------------------------------*/

static void gparam_uniform( paramfile pf );
static size_t init( size_t nphot );
static int pos2d( double *x, double *y );
static int pos1d( double * );

/*---------------------------------------------------------------*/

OutputDistribution
uniform_dist =
{
  "uniform",
    gparam_uniform,
    init,
    pos1d,
    pos2d
};

/*---------------------------------------------------------------*/

static void
gparam_uniform( paramfile pf )
{
  tf_enter( "gparam_uniform" );

  tf_leave();
}

static size_t
init( size_t nphot )
{
  return nphot;
}

static int
pos2d( double *x, double *y )
{
  *x = ranf() * ( c.xmax - c.xmin ) + c.xmin;
  *y = ranf() * ( c.ymax - c.ymin ) + c.ymin;

  return 0;
}

static int
pos1d( double *x )
{
  *x = ranf( ) * ( c.xmax - c.xmin ) + c.xmin;

  return 0;
}
