/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of linklist
 *
 * linklist is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * linklist is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <assert.h>
#include <stdio.h>

#include <linklist.h>

#define LEN(list) (sizeof(list) / sizeof(int))

int action( void *data )
{
  return ( * (int *)data == 6 );
}

int uaction( void *data, void *udata )
{
  return ( * (int *)data == * (int *) udata );
}

int cmp( const void *i1, const void *i2)
{
  return *((int *) i1) - *((int *) i2);
}

int
print_node( void *data, void *udata )
{
  printf( "%s: %d\n", (char *) udata, *((int *) data) );
  return 0;
}

int
main( int argc, char *argv[])
{
  int list[] = {1, 3, 5, 7, 9, 0, 2, 4, 6, 8};
  int *ptr;
  size_t i;

  SLinkList ll;
  DLLNode node;

  ll = dll_new( cmp );

  for ( i = 0 ; i < LEN(list) ; i++ )
    dll_insert( ll, &list[i] );

  assert( dll_count( ll ) == LEN(list) );

  assert( dll_traverse_d( ll, action, HEAD_TO_TAIL, &ptr ) && *ptr == 6);

  i = 8;
  assert( dll_utraverse_d( ll, uaction, &i, HEAD_TO_TAIL, &ptr ) && *ptr == i);

  dll_delete( ll, DLL_NULL_DELETE );

  return 0;
}

