/* C source for I1MACH */
/* Note that some values may need changing -- see the comments below. */
#include <stdlib.h>
#include <stdio.h>
#include <float.h>
#include <limits.h>
#include <math.h>

#include <config.h>

int 
F77_FUNC(i1mach,I1MACH)(int *i)
{
  switch (*i)
  {
    case 1:
      return 5;			/* standard input  unit -- may need changing */
    case 2:
      return 6;			/* standard output unit -- may need changing */
    case 3:
      return 7;			/* standard punch  unit -- may need changing */
    case 4:
      return 0;			/* standard error  unit -- may need changing */
    case 5:
      return sizeof(int) * CHAR_BIT;	/* bits per integer  */
    case 6:
      return 1;			/* Fortran 77 value: 1 character */
      				/*    per character storage unit */
    case 7:
      return 2;			/* base for integers -- may need changing */
    case 8:
      return sizeof(int) * CHAR_BIT - 1;	/* digits of integer base */
    case 9:
      return INT_MAX;
    case 10:
      return FLT_RADIX;
    case 11:
      return FLT_MANT_DIG;
    case 12:
      return FLT_MIN_EXP;
    case 13:
      return FLT_MAX_EXP;
    case 14:
      return DBL_MANT_DIG;
    case 15:
      return DBL_MIN_EXP;
    case 16:
      return DBL_MAX_EXP;
  }

  fprintf(stderr, "invalid argument: i1mach(%d)\n", *i);
  exit(1);
  return 0;			/* for compilers that complain of missing return values */
}
