use inc::Module::Install;

perl_version '5.008008';


name 'make-world';
license 'gpl3';

all_from 'src/make-world';


requires 'Cwd';
requires 'File::Copy';
requires 'File::Path';
requires 'File::Temp';
requires 'File::Spec::Functions';
requires 'Pod::Perldoc';
requires 'XML::Tiny';
requires 'Capture::Tiny';
recommends 'Getopt::ArgvFile';

bundle 'Test::More';
bundle 'XML::Tiny';
bundle 'Capture::Tiny';

# can't bundle Getopt::ArgvFile because of behavior of Test::Pod
# when there's no lib or blib directories to search for pod source
# bundle 'Getopt::ArgvFile';

install_script 'src/make-world';

if ( ( my $graft ) = grep { /--graft=(.*)/ } @ARGV )
{
    my ( $graft_root ) = $graft =~ /^--graft=(.*)/;
    my $install_base = "$1/" . name() . '-' . version();
    @ARGV = grep { ! /^--graft=/ } @ARGV;

    push @ARGV, "INSTALL_BASE=$install_base";
}

WriteAll;
