#!@PERL@

# --8<--8<--8<--8<--
#
# Copyright (C) 2010 Smithsonian Astrophysical Observatory
#
# This file is part of make-world
#
# make-world is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# make-world is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
#       Free Software Foundation, Inc.
#       51 Franklin Street, Fifth Floor
#       Boston, MA  02110-1301, USA
#
# -->8-->8-->8-->8--


use strict;
use warnings;

package MakeWorld::Package::Unknown;

use base 'MakeWorld::Package';
use Carp;

use MakeWorld::Global;

sub new
{
    my ( $package, $self ) = @_;

    return bless $self, $package;
}

sub configure
{
    my $self = shift;

    $self->SUPER::configure && return;

    die( "internal error: illegal call to ", __PACKAGE__, "::configure\n" )
      unless $opt{dryrun};

    if ( defined $self->{option}{configure}{arg} )
    {
	print STDOUT "configuring with arguments ",
	  join(' ', @{$self->{option}{configure}{arg}}), "\n";
    }
    else
    {
	print STDOUT "configuring\n";
    }
}

sub build
{
    my $self = shift;

    $self->SUPER::build && return;

    die( "internal error: illegal call to ", __PACKAGE__, "::build\n" )
      unless $opt{dryrun};

    if ( defined $self->{option}{build}{arg} )
    {
	print STDOUT "building with arguments ",
	  join(' ', @{$self->{option}{build}{arg}}), "\n";
    }
    else
    {
	print STDOUT "building\n";
    }
}

sub test
{
    my $self = shift;

    $self->SUPER::test && return;

    die( "internal error: illegal call to ", __PACKAGE__, "::test\n" )
      unless $opt{dryrun};

    if ( defined $self->{option}{test}{arg} )
    {
	print STDOUT "testing with arguments ",
	  join(' ', @{$self->{option}{test}{arg}}), "\n";
    }
    else
    {
	print STDOUT "testing\n";
    }
}


sub install
{
    my $self = shift;

    $self->SUPER::install && return;

    die( "internal error: illegal call to ", __PACKAGE__, "::install\n" )
      unless $opt{dryrun};

    if ( defined $self->{option}{install}{arg} )
    {
	print STDOUT "installing with arguments ",
	  join(' ', @{$self->{option}{install}{arg}}), "\n";
    }
    else
    {
	print STDOUT "installing\n";
    }
}

1;
