/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of mst_rdb
 *
 * mst_rdb is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * mst_rdb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

/* rdb_free_hdr.c */

#include "mst_rdb.h"

#include <stdlib.h>

#include <suplib/io.h>

/*

  PROCEDURE
    rdb_free_hdr - Frees the memory associated with an /rdb header.

  DESCRIPTION
    rdb_free_hdr - Frees the memory associated with an /rdb header.

  AUTHOR
    Diab Jerius

*/
void
rdb_free_hdr(
  rdbHeader *hdr	/* the header to free */
)
{
  if (hdr)
  {
    free(hdr->col_name);
    free(hdr->names);
    fget_rec_delete( hdr->buf );
    free(hdr);
  }
}
