#============================================================================
# prog_usage_cc_base.mk

# the caller must set POD_SRC to the name of the pod source file
# e.g.:

#  POD_SRC = $(top_srcdir)/docs/$(PACKAGE_NAME).pod 
#  POD_SRC = $(srcdir)/bin.pod 

# if POD_SRC is found via VPATH, then the command may not have
# the correct path to it, depending upon the make (Solaris make will
# rewrite the command, GNU make won't).  To catch this error early,
# explicitly check for the existence of it.
usage.cc : $(POD_SRC)
	test -f $(POD_SRC) || { echo "Bad VPATH in Makefile"; false; }
	pod2text < $(POD_SRC) | text2usage -pfx usage -csfx .cc -inc

MAINTAINERCLEANFILES	+= usage.cc usage.h
EXTRA_DIST		+= usage.cc usage.h
BUILT_SOURCES		+= usage.cc
