#include <cstdlib>

#include <paramxx/ParFile.h>

using namespace std;

int pardump( Par* par ) {

  string name( par->get_name( ) );
  if ( ParFile::is_comment( name.c_str( ) ) )
    return 0;

  cout << name.c_str( ) << "='" << par->get_value( ) << "'" << endl;

  return 0;

}

static int pardump( int argc, char** argv ) {

  try {

    ParFile pfile( argc, argv, argv[ 1 ] );
    pfile.traverse( pardump );
    cout << "# EOF" << endl;

    return EXIT_SUCCESS;

  } catch( ParFileException& pfe ) {
    cerr << pfe << endl;
    return EXIT_FAILURE;
  } catch( Exception& e ) {
    cerr << e << endl;
    return EXIT_FAILURE;
  }

}

int main( int argc, char** argv ) {

  if ( argc < 2 ) {
    cerr << "Usage:\t" << argv[0] << " pfile(s) [par1=val1]\n";
    return argc;
  }

  return pardump( argc, argv );
}

