#include <iostream>

using namespace std;
 
#include <stdlib.h>
#include <testlib/testlib.h>

int testParFilename( int argc, char** argv, bool printIt );
int testBoolPar( bool printIt );
int testCommentPar( bool printIt );
int testIntPar( bool printIt, int num );
int testRealPar( bool printIt, int num );
int testStringPar( bool printIt );
int testPar( int argc, char** argv, bool printIt );

int main( int argc, char** argv ) {

  int  num = 10;
  bool printIt = 0;

  START( "Testing ParFile class" );

  for ( int i = 1; i < argc; i++ ) {
    if ( 0 == ::strcmp( argv[ i ], "-p" ) )
      printIt = 1;
    else if ( 0 == ::strcmp( argv[ i ], "-n" ) )
      num = atoi( argv[ ++i ] );
    else {
      cerr << "Usage : " << argv[ 0 ] << " -p" << endl;
      return EXIT_FAILURE;
    }
  }

  if ( EXIT_FAILURE == testParFilename( argc, argv, printIt ) )
    return EXIT_FAILURE;

  if ( EXIT_FAILURE == testBoolPar( printIt ) )
    return EXIT_FAILURE;

  if ( EXIT_FAILURE == testCommentPar( printIt ) )
    return EXIT_FAILURE;

  if ( EXIT_FAILURE == testIntPar( printIt, num ) )
    return EXIT_FAILURE;

  if ( EXIT_FAILURE == testRealPar( printIt, num ) )
    return EXIT_FAILURE;

  if ( EXIT_FAILURE == testStringPar( printIt ) )
    return EXIT_FAILURE;

  if ( EXIT_FAILURE == testPar( argc, argv, printIt ) )
    return EXIT_FAILURE;

  SUMMARY();

  return EXIT_SUCCESS;

}
