/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of quef
 *
 * quef is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * quef is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <tparam/tparam.h>
#include <suplib/str.h>

#include <tracefct/tracefct.h>
#include <tracefct/exiterrvals.h>

#include "param_utils.h"
#include "gparam_def.h"

/*
  PROCEDURE
    Read the parameter pname from the parameter handle pf.

  RETURN
    Pointer to the string of the parameter pname.
*/
char* strpget( paramfile pf, char* pname )
{
  char string[MAX_LENGTH];
  char* strp;
  
  tpgetstr( pf, pname, string, MAX_LENGTH, 1 );

  if ( NULL == ( strp = str_dup( string ) ) )
    tf_exit( ExitERR_alloc, "Unable to allocate `%s'\n", string );

  return strp;
}


