#ifndef QUEF_DEF_H
#define QUEF_DEF_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of quef
 *
 * quef is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * quef is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

typedef enum {
  InterpLIN,
  InterpLOG
} InterpType;

typedef struct {
  double emin;
  double emax;
  double qemin;
  double qemid;
  double qemax;
} QuantumEfficiency;

typedef struct {
  QuantumEfficiency* qe;     /* pointer to lookup table */
  size_t num;                /* number of entries in lookup table */
  InterpType abcissa;              /* Type of interpolation */
  InterpType ordinate;             /* Type of interpolation */
  int kill;                  /* If yes then do not write out photon to
				bpipe if photon's energy is not within
				the lookup table */

  double qemin;		     /* minimum allowable qe value */
  double qemax;		     /* maximum allowable qe value */
  int    qeclip;	     /* clip qe's to allowable values? */

} QE;

typedef struct {
  char *in;                                                 /* input stream */
  char *out;                                               /* output stream */
} InOut;


#endif

