/* "Fundamental" algorithmic constants.

taken from L'Ecuyer & Cote, ACM Trans. V17, No. 1, March 1991, p 108.
comments from com.c

*/

/*
     V=20;                            W=30;
     A1W = MOD(A1**(2**W),M1)         A2W = MOD(A2**(2**W),M2)
     A1VW = MOD(A1**(2**(V+W)),M1)    A2VW = MOD(A2**(2**(V+W)),M2)

   If V or W is changed A1W, A2W, A1VW, and A2VW need to be recomputed.
   An efficient way to precompute a**(2*j) MOD m is to start with
   a and square it j times modulo m using the function MLTMOD.
*/

#define Xm1   2147483563L
#define Xm2   2147483399L
#define Xa1   40014L
#define Xa2   40692L
#define Xa1w  1033780774L
#define Xa2w  1494757890L
#define Xa1vw 2082007225L
#define Xa2vw 784306273L
