#include <stdio.h>
#include <float.h>
#include <limits.h>
#include <math.h>

#include "algo_consts.h"

#define gF "%.15g"

int
main(void)
{
  printf( "#include <float.h>\n");
  printf( "#include <limits.h>\n");

  printf( "/*     Close to the largest number that can be exponentiated = log(infnty) */\n" );
  printf( "#define EXPMAX " gF "\n", DBL_MAX_10_EXP * log(10.0) );
  printf( "\n" );

  printf( "/*     Exp(-1) */\n" );
  printf( "#define EXPMONE " gF "\n", exp(-1.0) );
  printf( "\n" );

  printf( "/*     1 / sqrt( 2 * PI ) */\n" );
  printf( "#define ONE_OVER_SQ2PI " gF "\n", 1 / sqrt( 4.0 * acos(0.0)) );
  printf( "\n" );

  printf( "/*     1 / 24 */\n" );
  printf( "#define ONE_OVER_24 " gF "\n", 1.0 / 24.0 );
  printf( "\n" );

  printf( "/*     1 / 12 */\n" );
  printf( "#define ONE_OVER_12 " gF "\n", 1.0 / 12.0 );
  printf( "\n" );

  printf( "/*     1 / 7 */\n" );
  printf( "#define ONE_OVER_7 " gF "\n", 1.0 / 7.0 );
  printf( "\n" );

  printf( "/*    1 / M1 */\n" );
  printf( "#define ONE_OVER_M1 " gF "\n", 1.0 / Xm1 );
  printf( "\n" );

  printf( "/*    sqrt(32) */\n" );
  printf( "#define SQRT32 " gF "\n", sqrt(32.0) );


  return 0;
}
