#ifndef DIST_H_included
#define DIST_H_included

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of raygen
 *
 * raygen is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * raygen is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */


typedef enum
{
  DT_NONE,
  DT_UNIFORM,
  DT_GAUSSIAN
} DistType;

typedef struct
{
  DistType	type;		/* distribution type */
  double	p[2];		/* distribution parameters.
				   0 = center,
				   1 = std dev
				*/
} Dist;

typedef struct
{
  int twoD;
  double gparm[2*(2+3)/2 + 1 ];	/* 2D Gaussian parameter storage */
  Dist x;
  Dist y;
} ImgDist;

void	get_ImgDist( const char *err_pfx, ImgDist *idist,
		     lua_Object optargs, double z );

void	gen_ImgDist( ImgDist *idist,
		     double *x, double xmin, double xmax, 
		     double *y, double ymin, double ymax );


#endif /* ! DIST_H_included */
