#ifndef LUA_INTERFACE_H
#define LUA_INTERFACE_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of raygen
 *
 * raygen is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * raygen is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <lua.h>

void tf_lua_error(void);

void define_error(const char *fmt, ...);

void lua_init( void );

void process_lua( char* script_file, char* override_script);

void get_lua_args(const char* func, ...);

void get_lua_args_n(const char* func, int n, ...);

char *get_lua_str_arg_p(const char* funcname, const char* argname);

void check_n_lua_arg(const char* func, int n);

void verify_empty_optargs(const char* func, lua_Object table);

char *get_string(const char* err_pfx, lua_Object optargs,
			   const char *index, const char *dflt);

#endif /* ! LUA_INTERFACE_H */
