/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of raygen
 *
 * raygen is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * raygen is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <stddef.h>

#include "main.h"

/*

   Instructions For Inserting A New Module
   ---------------------------------------
   1. declare the module's Module structure
   2. insert it in the list of modules, *before*
      the last, NULL, entry.

*/

/****************************************
 * 1. Declare Module structures *
 ****************************************/
extern Module mono_module;
extern Module flat_module;
extern Module spectrum_file_module;
extern Module image_module;
extern Module point_module;
extern Module rect_module;
extern Module disk_module;

/* -- declare new module structures above this line  -- */


/****************************************
 * 2. Insert the module structure       *
 ****************************************/
Module *modules[] =
{
  &image_module,
  &mono_module,
  &point_module,
  &rect_module,
  &spectrum_file_module,
  &flat_module,
  &disk_module,

/* -- place new module structures above this line  -- */

  NULL
};
