#ifndef ChipSize_H
#define ChipSize_H

#include <iostream>

#include <Exception/Exception.h>

#include <rdbxx/simpleRDBTable.h>

using namespace std;

class ChipSize {

  friend ostream& operator << ( ostream& os, ChipSize& a ) {
    a.print( os );
    return os;
  }

  friend ostream& operator << ( ostream& os, ChipSize* a ) {
    a->print( os );
    return os;
  }

public:

  enum Pos { XXX, YYY };

  virtual ~ChipSize( ) { }

  ChipSize( ) { }

  ChipSize( const char* header[], RDBColumn** rdb_column )
    throw( Exception );

  ChipSize( const ChipSize& c ) { *this = c; }

  ChipSize& operator = ( const ChipSize& rhs );

  void init_ChipSize( const char* header[], RDBColumn** rdb_column )
    throw( Exception );

  void print( ostream& os ) const;

protected:

  string name;

  int id;

  int chip_size_pix[ 2 ];

  double pixel_size_micron[ 2 ];

  double chip_size_mm[ 2 ];

};

#endif
