#include <cstdlib>

#include <rdbxx/simpleRDBTable.h>

#include "ChipSize.h"

int testit( ) {

  const char* rdb_size_header[] = { "chip", "id",
				    "xsize_pix",  "ysize_pix",
				    "xpixelsize", "ypixelsize",
				    "xsize_mm",   "ysize_mm", NULL };
  
  simpleRDBTable< ChipSize > my_rdb( "hrc-size.rdb", ios::in,
				     rdb_size_header );
  
  cout << my_rdb << endl;
  ChipSize* chip_size = NULL;
  while( NULL != (chip_size = my_rdb.readRow( )) ) {
    cout << *chip_size << endl;
    delete chip_size;
  }

  return 0;
}

int main( int argc, char** argv ) {

  try {
    testit( );

  } catch ( Exception& e ) {
    cerr << argv[0] << ":  " << e << endl;

  } catch ( exception& e ) {
    cerr << argv[0] << ":  " << e.what( ) << endl;

  } catch ( ... ) {
    cerr << "Caught something... not quite sure what though." << endl;

  }

  return EXIT_SUCCESS;

}
