#include <cstdlib>
#include <iostream>
#include <testlib/testlib.h>
#include <rdbxx/RDB.h>

using namespace std;

int main( int argc, char* argv[] ) {
  START( "RDB Test Suite" );

  try {
    RDB rdb1( argv[1], ios::in );

    TEST( "RDB::nComments( )", rdb1.nComments( ), 23 );
    TEST( "RDB::nColumns( )",  rdb1.nColumns( ),  51 );
    TEST( "RDB::nRows( )",     rdb1.nRows( ),     61 );

  } catch ( RDBErr& re ) {
    cerr << "Caught an RDBErr" << endl
	 << re << endl;

    // horrible, but the test suite can't handle exceptions...
    return EXIT_FAILURE;
  } catch ( ... ) {
    cerr << "Caught something unexpected..." << endl;

  }

  SUMMARY( );
  
  return FAILED( ) ? EXIT_FAILURE : EXIT_SUCCESS;
}
