// --8<--8<--8<--8<--
//
// Copyright (C) 2007 Smithsonian Astrophysical Observatory
//
// This file is part of rl_raylib
//
// rl_raylib is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// rl_raylib is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <rl_raylib/rl_Exception.h>

rl_Exception::~rl_Exception() throw () {}

rl_Exception::rl_Exception( const string& msg )
  : Exception( msg ) {}

rl_Exception::rl_Exception( const char* format, ... ) 
  : Exception() 
{
  va_list args;
  va_start( args, format );
  char str[ 8192 ];
  vsprintf( str, format, args );
  string msg = str;
  set_message( msg );
  va_end( args );

}

