*+
*KWIC getparam.f
*
*$Id: getparam.f,v 1.4 1998/10/10 21:24:38 gaetz Exp $ 
*
*Revisions:
*   96-Jun-03[T. Gaetz]
*      . original version; adapted from frSAOdrat/gparam.f and initsaofocus.f
*-
***** file: getparam.f <> $Revision: 1.4 $

*+**********************************************************************
      subroutine getparam( rcsid_string, db_extend)
************************************************************************
*
*kwic getparam --- read parameter file
*
*  arguments:
*
*  comments:
*
*  USER INPUTS :
*
*    96-Jun-03[T. Gaetz]
*       . original version
*
*$Id: getparam.f,v 1.4 1998/10/10 21:24:38 gaetz Exp $
*-
      implicit none

*---  named constants...
      INTEGER     LUNERR
      PARAMETER ( LUNERR = 0 )   ! unit number for 'stderr'
      DOUBLE PRECISION DEG2RAD
      PARAMETER      ( DEG2RAD = 1.d0 / 57.295779513082320876798155d0 )

*---  passed variables...
      CHARACTER*(*) rcsid_string

      INTEGER debugstring, db_extend   ! debug parameter stuff
      
*---  version info...
      include 'version.h'

*---  global variables...
      include 'saosacLib/iofiles.h'
      include 'saosacLib/parx.h'      ! gfoc, ndim, ns, kurf, ...
      include 'saosacLib/raystuff.h'
      include 'saosacLib/srfstuff.h'

*---  external routines...
      integer  c_paccess, len_trim, debug_init, dbflag
      external c_paccess, len_trim, debug_init, dbflag

*---  local variables...
      include 'param.h'
      integer           ln
      logical           version
      integer           vrsflag
      logical           fhelp
      integer		status
      
      character*(256) debug   

*CODE getparam -----------------------------------------------------------

*---  read in current surface number, gi filename, deformation filename...

      call paramopen( '$', '$r', pf )

      if ( pf .eq. 0 ) then
         write (LUNERR, * )
     &        'saofocus: unable to find parameter file'
         stop
      endif

      vrsflag = c_paccess( pf, 'version' )
      if ( vrsflag .ne. 0 ) then
         call pgetb( pf, 'version', version, status )
         if ( status .ne. 0 ) then
            write( LUNERR, * ) 
     &           'saofocus: error accessing parameter "version"'
            stop
         endif
         if ( version ) then
            write ( *, * ) VERSION_STRING
            stop
         endif
      endif

*---  initialize KURF ('current surface') to last surface
*     (given by NS, the number of surfaces).
      KURF = NS

      in = ' '
      call pgetstr( pf, 'input', in, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * ) 
     &        'saofocus: error accessing parameter "input"'
         stop
      endif

      out = ' '
      call pgetstr( pf, 'output', out, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * ) 
     &        'saofocus: error accessing parameter "output"'
         stop
      endif

      fnm_gi = ' '
      call pgetstr( pf, 'gi_filename', fnm_gi, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * ) 
     &        'saofocus: error accessing parameter "gi_filename"'
         stop
      endif

      log_file = ' '
      call pgetstr( pf, 'logfile', log_file, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * ) 
     &        'saofocus: error accessing parameter "logfile"'
         stop
      endif

      call pgetb( pf, 'help', fhelp, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * ) 
     &        'saofocus: error accessing parameter "help"'
         stop
      endif

      if ( fhelp ) then
         call usage
         stop
      end if

      call pgetb( pf, 'onlygoodrays', fgoodrays, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * )
     &        'saofocus: error accessing parameter "onlygoodrays"'
         stop
      endif

C   READ IN DEBUG PARAMETER TO EXTEND FIELDS
     
      db_extend = 0
      call pgetstr( pf, 'debug', debug, status )
      if ( status .ne. 0 ) then
         write( LUNERR, * )
     &        'saofocus: error accessing parameter "debug"'
         stop
      endif

      debugstring = debug_init( debug )
      db_extend =  dbflag('extend_all')    

      call paramclose ( pf )

      END ! getparam -----------------------------------------------------
