!+
!KWIC rain.h
!
!Id$
!
!History:
!   1996-Jun-05[T. Gaetz]
!      . moved from individual source files to included file.
!      . reordered:  double precision, real, integer.
!      . add save statement
!
!  DEFINITIONS (extracted from source files):
!
!  /RAIN/ VARIABLES INITIALIZED:
!    FOP  : R*8 - FRACTIONAL PORTION OF PATH LENGTH
!    IOP  : I*4 - INTEGER    PORTION OF PATH LENGTH
!    JRAY : I*4 - CURRENT RAY NUMBER
!    JING : I*4 - CURRENT RING NUMBER
!    MR   : I*4 - NUMBER OF RINGS IN CURRENT SPOKE
!    J2   : I*4 - CURRENT SPOKE NUMBER
!    KODE : I*4 - RAY STATUS CODE (SEE CHEX OUTPUT)
!    R    : R*4 - RADIUS OF CURRENT RING
!    W    : R*4 - RELATIVE INTENSITY OF RAY
!    Q0   : R*4 - UN-NORMALIZED 2ND DERIV. MATRIX OF SURF
!    Q3   : R*4 - NORMALIZED Q0
!  (C2COMP, S2COMP ADDED 2/4/88)
!    C2COMP: C*16 - 2-D COMPLEX AMPLITUDE OF COS (OMEGA T) POLARIZATION
!    S2COMP: C*16 - 2-D COMPLEX AMPLITUDE OF SIN (OMEGA T) POLARIZATION
!-

      COMPLEX * 16     C2COMP, S2COMP
      DOUBLE PRECISION FOP, W, Q0, Q3, R
      INTEGER          IOP, JRAY, JING, MR, J2, KODE
      COMMON /RAIN/    FOP, IOP, JRAY, JING, MR, J2, KODE, R, W,
     1                 Q0 (6), Q3 (6), C2COMP (2), S2COMP (2)
      SAVE   /RAIN/
