*+
*KWIC besjn1.f
*
*$Id: besjn1.f,v 1.1 2004/03/12 16:33:04 dtn Exp $
*
*Revisions:
*   95-Oct-10[T. Gaetz]
*      . eliminate output to unit 6
*-
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE BESJN1 (X, N, BJN, ERR, IER)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      IMPLICIT INTEGER (I-N)
      DATA ZERO/0.0D0/, ONE/1.0D0/
      DATA PI/3.141592653589793238462643D0/
C
C     ASYMPTOTIC SERIES FOR BJN
C
      PHASE = ONE
       DN   = DFLOAT(N)
       DMU = DN*DN *4.0D0
       EIGHTX = 8.0D0*X
       KTEST =  (N+N+1)/4
       TERM = ONE
       P= ONE
       Q = ZERO
       K = 0
  230  K=K+1
          OLDTRM = TERM
          DK = DFLOAT(K)
          TERM = TERM*(DMU-(DK+ONE)*(DK+ONE))/(DK*EIGHTX)
          IF(MOD(K,2) .NE.0) GO TO 120
            PHASE = -PHASE
            P = P + PHASE * TERM
          GO TO 130
C
C
  120     Q = Q + PHASE*TERM
          GO TO 130
  130 CONTINUE
C     WRITE(8,131) K,TERM,P,Q
C 131 FORMAT('  K,TERM,P,Q=',I5,1P3D20.10,/)
      IF(K.LT.KTEST) GO TO 230
      IF(P.NE.ZERO) ATMP = DABS(TERM/P)
      IF(P.EQ.ZERO) ATMP = DABS(TERM)
      IF ((ATMP .GT. ERR)
     A       .AND.(DABS(TERM) .LT. DABS(OLDTRM)))GO TO 230
C
C
C
      IF(DABS(TERM).GT.DABS(OLDTRM)) GO TO 140
C
C    ASYMPTOTIC SERIES SUCCESSFULLY CONVERGED
C
       CHI = X - (DN +DN+ONE)*PI*0.25D0
       BJN = P*DCOS(CHI)-Q*DSIN(CHI)
       BJN = BJN*DSQRT(2.0D0/(X *PI))
       RETURN
C
C   ASYMPTOTIC SERIES FAILED TO CONVERGE
C
 140   IF(K.LT.KTEST) GO TO 230
       IER = 1
       RETURN
       END
