      subroutine midnrg
c subroutine midnrg : mid energy
c                     the user needs more precise coordinates as
c                     the center of energy.
c                     this algorithm will find px and py , the row and
c                     column at which :
c                      abs(north-south)+abs(east-west) is minimum.
c                     where - north is the integrated energy of the rows
c                     above px . the south is the energy of the rows
c                     below px . etc...
c
c
      IMPLICIT DOUBLE PRECISION (A-H, O-Z), INTEGER (I-N)

c            the energy of each row and column
      DOUBLE PRECISION sumrow(101)
      DOUBLE PRECISION sumcol(101)
      DOUBLE PRECISION north , south , east , west
c            the minimum so far
      DOUBLE PRECISION cdiff
c            the computed differences - abs(north-south)+...
      DOUBLE PRECISION offcen
c  global variables for programs that use osac fp pixel array
c
      INCLUDE 'pixels.h'
c                               
c initializing cdiff to some large value
      cdiff = 100000.0
      do 10 i = 1 , nrow
         sumrow(i) = 0.0
         do 20 j = 1 , ncol
            sumrow(i) = sumrow(i) + intensity(i,j)
   20    continue
   10 continue
c
      do 30 j = 1 , ncol
         sumcol(j) = 0.0
         do 40 i = 1 , nrow
         sumcol(j) = sumcol(j) + intensity(i,j)
   40    continue
   30 continue
c
      do 50 i = 20 , min(nrow,80)
         north =0.0
         do 60 n = 1 , i-1
            north = north + sumrow(n)
   60    continue
         south = 0.0
         do 70 n = i+1 , nrow
            south = south + sumrow(n)
   70    continue
c
         do 80 j = 20 , min(ncol,80)
            east = 0.0
            do 90 n = 1 , j-1
               east = east + sumcol(n)
   90       continue
            west = 0.0
            do 100 n = j+1 , ncol
               west = west + sumcol(n)
  100       continue
c
            offcen = abs(north-south)+abs(east-west)
            if ( offcen .lt. cdiff ) then
               cdiff = offcen
               px = i
               py = j
            end if
   80    continue
   50 continue
c
      return
      end
