      double precision function sumrad( radius )
c function sumrad : sum on radius
c                   integrates intensity values of pixels over a given
c                   radius.
c
c
      IMPLICIT DOUBLE PRECISION (A-H, O-Z), INTEGER (I-N)

c
c  global variables for programs that use osac fp pixel array
c
      INCLUDE 'pixels.h'
c
      DOUBLE PRECISION radius
c
      integer diag , horiz
c  the diagonal and horizontal fit. used in fitting square pixels in a
c  circle
c
c  initializing
c
      diag = aint( radius/sqrt(2.) - .5)
      horiz = aint(radius - .5)
      sumrad = 0.
c
c  sum up pixels over largest square that can fit
c
      do 10 i = px - diag , px + diag
         do 20 j = py - diag , py + diag
         sumrad = sumrad + intensity(i,j)
   20    continue
   10 continue
c
c  sum on axes : east , west , north , south
c
      if ( horiz .gt. diag ) then
         do 30 i = diag+1 , horiz
         sumrad = sumrad +
     1   intensity( px+i , py ) +
     2   intensity( px-i , py ) +
     3   intensity( px , py-i ) +
     4   intensity( px , py+i )
   30    continue
      end if
c
c  checking on octants
c
      do 40 i = 1 , diag
         do 50 j = diag+1 , horiz
         if( (.5+i-1)**2 + (.5+j)**2 .lt. radius**2 .and.
     1       (.5+i)**2 + (.5+j-1)**2 .lt. radius**2 ) then
         sumrad = sumrad +
     1   intensity( px+j , py+i ) +
     2   intensity( px+i , py+j ) +
     3   intensity( px-i , py+j ) +
     4   intensity( px-j , py+i ) +
     5   intensity( px-j , py-i ) +
     6   intensity( px-i , py-j ) +
     7   intensity( px+i , py-j ) +
     8   intensity( px+j , py-i )
         else
           go to 40
c no need to check for larger j
         end if
   50    continue
   40 continue
c
      return
      end
