import three;
import math;
texpreamble("\usepackage{bm}");

bool intrinsic_axes = false;

currentprojection=perspective(500,1100,500); 

// Incident ray parameters 
real graze = 30;

// Scatter parameters
real theta = radians(10);
real phi = radians(30);

include init;


draw(Label("$\bm{\hat{i}}$",0.2), -i--O,Arrow, align=2N);
draw(Label("$\bm{\hat{r}}$", 0.8), O--r,Arrow, align=2N);

draw( Label("$\bm{\alpha}$"), 
      arc(O, -0.8 * v, -0.8 ang_rad * i, normal = u), 
      small_arcarrows );
draw( Label("$\bm{\alpha}$"),
       arc(O, ang_rad * v, ang_rad * r, normal = -u ),
       small_arcarrows
     );

triple l = cos(phi) * v + sin(phi) * u;

draw( Label("$\bm{\hat{l}}$", 1), O -- l, Arrow );
draw( Label("$\bm{\phi}$"), 
      arc(O, ang_rad * v, ang_rad * l, normal = -n ),
      N,
      small_arcarrows
      );

triple s = -sin(alpha + theta) * n + cos(alpha + theta) * l;

draw( Label("$\bm{\hat{s}}$", 1), O -- s, Arrow );
draw( Label("$\bm{\alpha + \theta}$"), 
      arc(O, ang_rad * l, ang_rad * s),
      E,
      small_arcarrows
      );


include finish;
