/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of suplib
 *
 * suplib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * suplib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#include "debug/debug.h"

/*

  PROCEDURE
  die - print a formatted message and exit with error

  DESCRIPTION
  @code{die} is a quick and dirty method of printing an error message
  and then exiting a program.  It's just a combination of @code{fprintf} and
  @code{exit}, sending the output to @code{stderr} and exiting with an
  exit value of @samp{1}

  AUTHOR
  Diab Jerius
*/
void
die(
  char *format,		/* the @code{printf} style format string for the message */
  ...			/* the arguments that make up the message */
  )
{
 va_list ap;

 va_start(ap, format);
 vfprintf(stderr, format, ap);
 va_end(ap);

 exit(1);
}

/* \endc */
