#ifndef SUPLIB_STATS_H
#define SUPLIB_STATS_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of suplib
 *
 * suplib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * suplib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


int gsmirn( int nx, int ny, int kind, int *m, double dstat, double *q );
int gsmirn2( int nx, int ny, int kind, int *m, double dstat, double *q );

int stcalc(int icw, int nx, int ny, double *x, double *y, int *k,
	   int **m, double *dstats);


int kolmogorov(int n, double d, double *p);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* !SUPLIB_STATS_H */
