/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of suplib
 *
 * suplib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * suplib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <ctype.h>

#include "str/str.h"

/*

  PROCEDURE
  str_rep - replaces all occurances of a character in a string with another

  DESCRIPTION
  @code{str_rep} scans a string, replacing every occurance of a the
  specified character with another.

  RETURNS
  It returns the pointer to the string which was passed.

  AUTHOR
  Diab Jerius


*/

char *
str_rep(
  char *str,	/* the string to scan */
  int c_old,	/* the character to be replaced */
  int c_new	/* the character to be inserted */
  )
{
  char *s;

  for (s = str; *s; s++)
    if (*s == c_old)
      *s = c_new;

  return (str);
}
