/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of suplib
 *
 * suplib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * suplib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <ctype.h>
#include <string.h>

#include "str/str.h"

/*

  PROCEDURE
  str_trunc - truncate white space at the end of a string

  DESCRIPTION
  @code{str_trunc} truncates white space at the end of a string by
  writing a @samp{\0} at the appropriate position in the string.
  It alters the passed string.

  RETURNS
  It returns the pointer which it was passed.

  AUTHOR
  Diab Jerius
*/
char *
str_trunc(
  char *string		/* the string to truncate */
  )
{
  char *s;

  if (string && *string)
  {
    /* end of string */
    s = string + strlen(string);
    
    /* find last non-white space character */
    while (--s >= string && isspace (*s));

    /* seal off string */
    *(s+1) = '\0';
  }

  return string;
}
