-- --8<--8<--8<--8<--
--
-- Copyright (C) 2007 Smithsonian Astrophysical Observatory
--
-- This file is part of suplib_lua
--
-- suplib_lua is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or (at
-- your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- -->8-->8-->8-->8--


---------------------------------------------------------------------
-- a simple function to copy a table.  it can perform "deep" copies,
-- but cannot handle recursive tables, will go into an infinite loop.

function table_copy( what, deep )

   local copy = {}             -- create a new table
   local i, v = next(what, nil)  -- i is an index of t, v = t[i]

   while i do

      if type(v)=="table" and deep then
	 v = table_copy(v, deep) 
      end

      copy[i] = v

      i, v = next(what, i)        -- get next index
   end

  return copy

end
