#ifndef SUPLIB_PP_COLSELECT_H
#define SUPLIB_PP_COLSELECT_H

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of suplibxx
//
// suplibxx is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// suplibxx is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <algorithm>
#include <set>
#include <string>
#include <vector>
#include <pcre.h>
#include <Exception/Exception.h>

using namespace std;

namespace suplib {

  void colselect( const vector<string>& icolumns, const vector<string>& exact_add, const vector<string>& regex_add, const vector<string>& exact_del, const vector<string>& regex_del, vector<string>& ocolumns ) throw ( Exception );

  bool match( const string& str, const string& pattern ) throw ( Exception );

} // namespace suplib

#endif
