// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of suplibxx
//
// suplibxx is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// suplibxx is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <string>

using namespace std;

#include "str.h"

#define WS " \t\n\r"


/*!
 * \ingroup str
 * \brief remove leading white space from a string
 *
 *
 * \param str the string upon which to operate
 *
 * trim deletes leading white space, where white space
 * is defined as blanks, tabs, new lines, and carriage returns.
 *
 * \return It returns the passed reference
 */


string&
suplib::trim( string& str )
{
  str.erase(0, str.find_first_not_of( WS ) );
  return str;
}
