// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of suplibxx
//
// suplibxx is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// suplibxx is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <iostream>
#include <string>
#include "colselect.h"
#include <testlib/testlib.h>

using namespace std;

/*
void test_match( void ) {
  string str( "A_eff1.2" ), pat1( "^[A-Z].+\\d$" ), pat2( "\\-" );

  TEST( "match, `A_eff1.2' =~ /^[A-Z].+\\d$/", suplib::match( str, pat1 ), true  );
  TEST( "match, `A_eff1.2' !~ /\\-/", suplib::match( str, pat2 ), false );
*/
  /* Actually... I don't think I can force it the throw something.
    bool thrown = false;
    try {
      suplib::match( , );
    
    } catch ( Exception& E ) {
      thrown = true;

    }
    TEST( "", thrown, true );
  */
/*
}
*/
/*
void test_colselect( void ) {
  vector<string> icolumns, acolumns, racolumns, dcolumns, rdcolumns, ocolumns, ecolumns;

  icolumns.insert( icolumns.begin( ), "col0" );// a d
  icolumns.insert( icolumns.begin( ), "Col1" );//aadd
  icolumns.insert( icolumns.begin( ), "COl2" );//   
  icolumns.insert( icolumns.begin( ), "COL3" );//   
  icolumns.insert( icolumns.begin( ), "COL$" );// a d
  icolumns.insert( icolumns.begin( ), "5loc" );//a d

  acolumns.insert( acolumns.begin( ), "5loc" );
  acolumns.insert( acolumns.begin( ), "foo" );
  acolumns.insert( acolumns.begin( ), "Col1" );

  racolumns.insert( racolumns.begin( ), "ol" );
  racolumns.insert( racolumns.begin( ), "\\$" );

  dcolumns.insert( dcolumns.begin( ), "5loc" );
  dcolumns.insert( dcolumns.begin( ), "foo" );
  dcolumns.insert( dcolumns.begin( ), "Col1" );

  rdcolumns.insert( rdcolumns.begin( ), "ol" );
  rdcolumns.insert( rdcolumns.begin( ), "\\$" );

  suplib::colselect( icolumns, acolumns, racolumns, dcolumns, rdcolumns, ocolumns );
  TEST( "colselect", ocolumns, ecolumns  );

}
*/
int main( void ) {
  
  START( "suplib::colselect" );

  string str( "A_eff1.2" ), pat1( "^[A-Z].+\\d$" ), pat2( "\\-" );

  TEST( "match, `A_eff1.2' =~ /^[A-Z].+\\d$/", suplib::match( str, pat1 ), true  );
  TEST( "match, `A_eff1.2' !~ /\\-/", suplib::match( str, pat2 ), false );

  vector<string> icolumns, acolumns, racolumns, dcolumns, rdcolumns, ocolumns, ecolumns;

  icolumns.insert( icolumns.begin( ), "col0" );// a d
  icolumns.insert( icolumns.begin( ), "Col1" );//aadd
  icolumns.insert( icolumns.begin( ), "COl2" );//   
  icolumns.insert( icolumns.begin( ), "COL3" );//   
  icolumns.insert( icolumns.begin( ), "COL$" );// a d
  icolumns.insert( icolumns.begin( ), "5loc" );//a d

  acolumns.insert( acolumns.begin( ), "5loc" );
  acolumns.insert( acolumns.begin( ), "foo" );
  acolumns.insert( acolumns.begin( ), "Col1" );

  racolumns.insert( racolumns.begin( ), "ol" );
  racolumns.insert( racolumns.begin( ), "\\$" );

  dcolumns.insert( dcolumns.begin( ), "5loc" );
  dcolumns.insert( dcolumns.begin( ), "foo" );
  dcolumns.insert( dcolumns.begin( ), "Col1" );

  rdcolumns.insert( rdcolumns.begin( ), "ol" );
  rdcolumns.insert( rdcolumns.begin( ), "\\$" );

  suplib::colselect( icolumns, acolumns, racolumns, dcolumns, rdcolumns, ocolumns );
  TEST( "colselect", ocolumns, ecolumns  );

  SUMMARY( );

  return FAILED( );
}

