/*

  DO NOT WRAP LINES!!!
  different platforms give different __LINE__ results for wrapped
  macro invocations.

*/
#include <float.h>
#include <stdio.h>
#include <stdlib.h>

#include <testlib/testlib.h>

int main( int argc, char *argv[] )
{


  START("Testing Test");

  {
    int a = 3;
    int b = 2;

    TEST("TEST, PASSED",  1, 1);
    TEST("TEST, PASSED",  a, a);
    TEST("TEST, **FAILED**", 1, 0);
    TEST("TEST, **FAILED**", a, b);

    TEST_RUN("TEST_RUN, PASSED", a = 4, a, 4 );
    TEST_RUN("TEST_RUN, **FAILED**", a = 3, a, 4 );

  }
  
  {
    char *a = "foo";
    char *b = "bar";

    TESTSTRING( "TESTSTRING, PASSED", a, a );
    TESTSTRING( "TESTSTRING, **FAILED**", a, b );
  }

  {
    double d = 22.2;
    double e = 22.3;

    TEST_FP( "TEST_FP, **FAILED**", d, e );
    TEST_FP( "TEST_FP, exact, PASSED", d, d );

    d = e + 20 * DBL_EPSILON;
    TEST_FP( "TEST_FP, fuzzy, PASSED", d, e );

    TEST_FP_TOL( "TEST_FP_TOL, exact, PASSED", d, d, 0.0 );

    d = 22.2;
    e = 22.3;
    TEST_FP_TOL( "TEST_FP_TOL, **FAILED**", d, e, 0.001 );
    TEST_FP_TOL( "TEST_FP_TOL, fuzzy, PASSED", d, e, 0.01 );

    TEST_RUN_FP( "TEST_RUN_FP, exact, PASSED", double g = d, g, d );
    TEST_RUN_FP( "TEST_RUN_FP, fuzzy, PASSED", double g = d + 20 * DBL_EPSILON, g, d );
    
    TEST_RUN_FP( "TEST_RUN_FP, **FAILED**", double g = d * ( 1.0 + 200 * DBL_EPSILON ), g, d );
    
    TEST_RUN_FP_TOL( "TEST_RUN_FP_TOL, exact, PASSED", double g = d, g, d, 1 );
    TEST_RUN_FP_TOL( "TEST_RUN_FP_TOL, fuzzy, PASSED", double g = d + 10 * DBL_EPSILON, g, d, 20 * DBL_EPSILON );
    
    TEST_RUN_FP_TOL( "TEST_RUN_FP_TOL, **FAILED**", double g = d + 200 * DBL_EPSILON, g, d, 200 * DBL_EPSILON / d );
  }

  SUMMARY();

  printf( "Expect 8 failures\n" );

  return FAILED() != 8 ? EXIT_FAILURE : EXIT_SUCCESS;
}
