#ifndef MAIN_H
#define MAIN_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of throttle
 *
 * throttle is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * throttle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#define NAME_LENGTH 255

typedef enum
{
  Abort_None,
  Abort_IfLessThan,
  Abort_IfGreaterThan
} AbortType;

typedef struct
{
  char input[NAME_LENGTH+1];
  char output[NAME_LENGTH+1];

  long seed1, seed2, block;

  long n;
  
  AbortType abort;
  int poisson;
  int version;
  int help;
} Common;

#endif /* !MAIN_H */
