#include <Exception/Exception.h>
using namespace std;
#include "TraceFct.h"


void f2( void )
{
  static int level = 0;
  TraceFct tf( "f2" );

  level++;
  tf.message( "message test: %d\n", level );
  tf.message( "1. multiline\n2. message test\n" );
  tf.message( "f2 stack dump:\n" );
  tf.dump_stack( );

  if ( level < 12 )
    f2();

#ifdef F2DIEMSG
  tf.die( "f2 exit: line1\nf2 exit: line2" );
#endif

#ifdef F2DIEVARARGS
  tf.die( "f2 exit: line1\nf2 exit: line2 %s", "foobar" );
#endif

#ifdef F2EXIT
  tf.exit( 1, "f2 exit: line1\nf2 exit: line2" );
#endif
}

void f1( void )
{
  TraceFct tf( "f1" );

  f2();


#ifdef F1EXIT
  tf.exit( 1, "f1 exit: line1\nf1 exit: line2, extra newline\n" );
#endif
}

int main( int argc, char * argv[] )
{
  int print_it = 0 ;
  int num_fct_to_print = -1 ;
  char *logfile = NULL;

  if ( argc > 1 )
    print_it = atoi(argv[1]);

  if ( argc > 2 )
    num_fct_to_print = atoi(argv[2]);


  if ( argc > 3 )
    logfile = argv[3];

#ifndef NOINIT
  TraceFct tf( "foo", print_it, num_fct_to_print );

  if ( logfile )
    tf.open( logfile );
#endif
  
  f1();

#ifdef MAINEXIT
  tf.exit( 1, "main exit" );
#endif

#ifndef NOINIT
  tf.close( );
  
  tf.message( "main stack dump\n" );
  tf.dump_stack( );
#endif

  return EXIT_SUCCESS;
}

