// File:   t_vm.cc
// Author: Terry Gaetz

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of vm_math.cvs
//
// vm_math.cvs is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// vm_math.cvs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include <cstdlib>
#include <iostream>
#include <testlib/testlib.h>

void test_vm_VMath();
void test_vm_V3Math();
void test_vm_M3Math();

using std::cerr;

int 
main( int argc, char** argv ) 
{
  int ch; 
  int printit = 0;
  while ( --argc > 0 && (*++argv)[0] == '-' )
  {
    while ( (ch = *++argv[0]) )
    {
      switch( ch ) 
      {
      case 'p':                   // print out diagnostics as we go along
        printit = 1;
        break;
      default:
        cerr << "Usage: " << argv[0] << " [-p]\n";
        return EXIT_FAILURE;
      }
    }
  }

  START("vm package:  vm_VMath");
  test_vm_VMath();
  SUMMARY();

  START("vm package:  vm_V3Math");
  test_vm_V3Math();
  SUMMARY();

  START("vm package:  vm_M3Math");
  test_vm_M3Math();
  SUMMARY();

  return 0;
}
